$(function() {
  $('#filterForm').submit(function(e) {
    e.preventDefault();
    var formData = $(this).serializeArray();
    $('#submitFilter').val("Loading...").attr("disabled", "disabled");
    $('#previewPane').empty();
    $.post("files/json_list", formData, function(data) {
      $('#submitFilter').val("Submit").removeAttr("disabled");
//      MAAKICHUT = response;
      var files = data.files;
//      console.log(files);
      $('#fileList').empty();
      $('#noOfPages').text(data.noOfPages);
      $('#noOfResults').text(data.noOfResults);
      $('#currentPageNo').text($('#page_no').val());
      for (var i=0; i<files.length; i++) {
//        console.log(files[i]);
        var $file = getJQ(files[i]);
        $('#fileList').append($file);
      }
    }, "json");
  });

  $('#prevBtn').click(function() {
    var $page_no = $('#page_no');
    var currPage = parseInt($page_no.val());
    if (currPage > 1) {
      $page_no.val(currPage - 1);
      $('#filterForm').submit();
    }
  });

  $('#nextBtn').click(function() {
    var $page_no = $('#page_no');
    var currPage = parseInt($page_no.val());
    $page_no.val(currPage + 1);
    $('#filterForm').submit();
  });

});

function getJQ(f) {
  var jq = $("<div />").data("data", f).addClass("fileItem").text(f.type + ": " + f.title);
  jq.click(function() {
    var $this = $(this);
    $('.selectedItem').removeClass("selectedItem");
    $this.addClass("selectedItem");
    var d = $this.data("data");
    var $pane = $('<div />').addClass("previewPane");
    var $previewObj = $('<div />').addClass("previewObject").appendTo($pane);
    var html = '';
    switch (d.type) {
      case "image":
        html += "<img width='400' src='" + d.thumbnail + "' />";
        break;
      case "video":
        html += "<video width='400' src='" + d.url + "' />";
        break;
      case "audio":
        html += "<audio width='400' src='" + d.url + "' />";
        break;
      default:
        html += "";
        break;    
    };
    html += "<br />";
    html += "<a href='" + d.url + "' target='_blank'>Click to View Original File</a>"; 
    $previewObj.html(html);
    $itemForm = getItemForm(f);
    $itemForm.appendTo($pane);
    $('#previewPane').empty();
    $('#previewPane').append($pane);
  });
  return jq;
}

function getItemForm(f) {
  var $form = $('<div />').addClass("itemForm");
  var $title = $('<input />').val(f.title).appendTo($form);
  var $description = $('<textarea />').val(f.description).appendTo($form);
  var $submit = $('<input />').addClass("submitItem").attr("type", "submit").val("Submit").appendTo($form);
  return $form; 
}
